/************************************************************************************/
/*  Program name CAPGLIMP_GL_CONCURRENCY_CONTROL.sql                                */
/*  Creater:  CHAN BILLY KA KEUNG (PCCW - UniHub)                                   */
/*************   History   *************************                                */
/* 24 MAY 2006				       First created                                    */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPGLIMP_CONC_CONTROL';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_GL_CONC_CONTROL;
		
	
BEGIN
	FOR C1 IN Cur_F LOOP
		BEGIN
						
			INSERT INTO GL_CONCURRENCY_CONTROL
			VALUES
			(
			C1.CONCURRENCY_CLASS      , 
			C1.CONCURRENCY_ENTITY_NAME ,
			CAPBRIMP_MAPPING.GetSOBIDMapping(C1.CONCURRENCY_ENTITY_ID),
			C1.LAST_UPDATE_DATE        ,
			C1.LAST_UPDATED_BY         ,
			C1.CREATION_DATE           ,
			C1.CREATED_BY              ,
			C1.LAST_UPDATE_LOGIN  
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;

	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;
	
	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);
	
	COMMIT;
END;
/